"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChainOfResponsibility = exports.StopBackwardExecution = void 0;
function StopBackwardExecution(retVal) {
    this.stopDuty(retVal);
    return retVal;
}
exports.StopBackwardExecution = StopBackwardExecution;
/**
 * @description 责任链
 */
class ChainOfResponsibility {
    constructor(fn, params) {
        this.taskList = [];
        this.taskList.push(fn);
        this.parameter = params;
    }
    dispatch(params) {
        if (params)
            this.editParams(params);
        this.loopExecution();
        return this.customReturnValue || this.nextParams;
    }
    loopExecution(rewrite) {
        var _a, _b, _c;
        // 使用了StopBackwardExecution函数后不在继续执行
        if (this.customReturnValue)
            return;
        const execution = (_b = (_a = this.taskList) === null || _a === void 0 ? void 0 : _a.shift()) === null || _b === void 0 ? void 0 : _b.call(this, rewrite || this.parameter);
        this.nextParams = execution;
        // 此处的判断是判断函数中是否使用中断函数
        if (this.customReturnValue)
            return;
        // 真值 且 没有中断
        if (!this.customReturnValue && ((_c = this.taskList) === null || _c === void 0 ? void 0 : _c.length)) {
            this.loopExecution(this.nextParams || this.parameter);
        }
    }
    /**
     * @description 停止职责
     */
    stopDuty(retVal) {
        this.customReturnValue = retVal;
    }
    addChain(fn) {
        var _a;
        (_a = this.taskList) === null || _a === void 0 ? void 0 : _a.push(fn);
        return this;
    }
    editParams(params) {
        this.parameter = params;
    }
}
exports.ChainOfResponsibility = ChainOfResponsibility;
